\documentclass[12pt]{IEEEtran}

\usepackage[margin=0.5in,bottom=.7in,top=.8in]{geometry}
\usepackage{graphicx}\graphicspath{{figures/}}
\usepackage[usenames,dvipsnames]{xcolor}
\usepackage[colorlinks=true,citecolor=Mahogany,linkcolor=Mahogany,urlcolor=Mahogany,filecolor=Mahogany]{hyperref}
\usepackage{breakurl}
\usepackage{url}
%\usepackage[nocompress]{cite}
\usepackage{paralist}
%\usepackage{authblk}
\usepackage{enumitem}
\usepackage[utf8]{inputenc}
\usepackage{amsmath}
\usepackage{amsfonts}
\usepackage{amssymb}
\usepackage{graphicx}
\usepackage{listings}

\title{NFD Performance Measurement and Tuning}
\author{Susmit Shannigrahi, Steve DiBenedetto, Christos Papadopoulos \\ Colorado State University}

\date{Dec 8th, 2015}

\usepackage{fancyhdr}
\pagestyle{fancy}


\usepackage{eso-pic,xcolor}
\makeatletter
\AddToShipoutPicture*{%
\setlength{\@tempdimb}{20pt}%
\setlength{\@tempdimc}{\paperheight}%
\setlength{\unitlength}{1pt}%
\put(\strip@pt\@tempdimb,\strip@pt\@tempdimc){%
    \makebox(0,-60)[l]{\color{blue}%
NDN, Technical Report NDN-0056. \url{http://named-data.net/techreports.html}}
  }%
}
\makeatother


\begin{document}
\maketitle

\begin{abstract}
In this work, we look at NFD's performance over TCP tunnel. We use large data packets as a way to reduce signing and
verification cost and  achieve 4.5Gbps throughput on a 10Gbps link.
\end{abstract}

\section{Introduction}


NDN Forwarding Daemon\cite{zhang2014named} (NFD) is a network forwarder that implements and evolves together with the Named Data
Networking (NDN) protocol [1]. The purpose of this document is to provide a performance study of NFD for users and developers. We provide a number of performance tests and present throughput with varying object size. We have used a private testbed on ESNet \cite{esnet} with six nodes. The nodes are connected with 10Gbps links and are located in various parts of United States.

\section{Topology and methodology}

\begin{figure}[!ht]
\begin{center}
\includegraphics[width=\linewidth]{figures/atmos-testbed-TR.png}
\caption{Testbed Topology}
\label{fig:}
\end{center}
\end{figure}

We used four nodes on the climate testbed\cite{olschanowsky2014supporting}\cite{shannigrahi2015named} for the performance tests. The nodes are located at Berkeley, Sacramento, Denver and Fort Collins. They are connected with 10Gbps links. The average RTT between the nodes are noted below.

For the experiment, we used a producer which can send specified number of object. The user can also specify the size of each object. Upon startup, the producer pushes all data into NFD's CS. This eliminates application level delays on the sender size. We also modified NFD to log various timestamps.

On the receiver side, we used a consumer application. User can specify how many objects to fetch, the amount of pipeline and the namespace. Again, we modified NFD to log receiver side timestamps.


\begin{center}

\begin{tabular}{|c|c|}
\hline 
Berkeley-Sacramento & 4.5ms \\ 
\hline 
Berkeley-Denver & 21.2ms \\ 
\hline 
Berkeley-Fort Collins & 23.3ms \\ 
\hline 
\end{tabular} 

\end{center}

\section{Experiments}

\subsection{Iperf Performance}
To establish a baseline, we did a proformance measurement between the nodes. The closer nodes reaches almost 10Gbps, though throughput between geographically distant hosts increased linearly as object size increased.

\begin{figure}[!t]
\begin{center}
\includegraphics[width=\linewidth]{figures/iperf_performance.png}
\caption{Object Size vs Throughput}
\label{fig:}
\end{center}
\end{figure}


\subsection{NFD Throughput vs object size}

All the following experiments use NFD. The first experiment shows how throughput changes with object size. This experiment was done between Berkeley and Sacramento. With a pipeline of 2, maximum throughput is reached with an object size of 300 MB. After that, throughput does not increase with object size. 

\begin{figure}[!t]
\begin{center}
\includegraphics[width=\linewidth]{figures/throughput_vs_object_size.png}
\caption{Object Size vs Throughput}
\label{fig:}
\end{center}
\end{figure}



\subsection{Performance vs Pipeline}
The second experiment shows change in throughput with number of pipelined Interests.  This experiment was done between Berkeley and Sacramento. Throughput increases as number of pipelined Interests go up, but only upto a certain amount. The throughput difference between using 10 and 15 Interests are small. We have tried as many as 50 pipelined Interest for retrieval without a significant change in throughput. The throughput maxes out at around 3.7Gbps.

\begin{figure}[!ht]
\begin{center}
\includegraphics[width=1\linewidth]{figures/pipeline_size_vs_throughput.png}
\caption{Pipeline Size vs Throughput}
\label{fig:}
\end{center}
\end{figure}

\subsection{Performance comparison between default and tuned TCP stack}

This experiment was also done between Berkeley and Sacramento. The previous two experiments were done with default TCP stack on Linux boxes. We then tuned the TCP stack per ESNet TCP tuning guide \cite{esnet_guide}. The difference was very noticeable. The performance went up from average 3.7Gbps to average of 4.7 Gbps for larger objects and pipeline of 15. While retrieving 1GB objects, individual throughputs around 5.3Gbps were observed.


\begin{figure}[!t]
\begin{center}
\includegraphics[width=1\linewidth]{figures/tcp_tuned_vs_non_tuned.png}
\caption{Tuned vs non-tuned TCP performance}
\label{fig:}
\end{center}
\end{figure}


\subsection{Throughput vs number of hops}
This experiment shows how NFD's performance degrades with number of hops. We found that with each hop, performance degrades by around 500Mbps. The low throughput between CSU and LBL (red line) for certain data sizes can be attributed to its being shared with other traffic. 

\begin{figure}[!t]
\begin{center}
\includegraphics[width=1\linewidth]{figures/throughput_vs_hops.png}
\caption{Throughput vs Number of Hops}
\label{fig:}
\end{center}
\end{figure}


\subsection{Performance comparison with and without caching}
We found that caching does not have much effect on NFD's throughput. With a two hop test between DEN and LBL, we measured the throughput at the SAC node, which is in the middle. We did not find much difference in throughput with or without caching.

\begin{figure}[!t]
\begin{center}
\includegraphics[width=1\linewidth]{figures/caching_vs_nocaching.png}
\caption{NFD throughput with and without caching}
\label{fig:}
\end{center}
\end{figure}


\subsection{Sender side write throughput}
To see how fast NFD can write to the wire, we sampled the write interval between NFD's $async\_write$ calls. The average write throughput remains static with amount of data, around 6.2 Gbps. The only exception is small objects below 100MB, where the write throughput goes up to around 8Gbps. 

However, the average send time per $async\_write$ goes up linearly with object size.
\begin{figure}[!ht]
\begin{center}
\includegraphics[width=1\linewidth]{figures/sender_side_throughput_vs_object_size.png}
\caption{Server Side Performance}
\label{fig:}
\end{center}
\end{figure}

\subsection{Receiver side performance}

To see how fast NFD is reading from the socket, we plotted the average time between NFD's  $decodeAndDispatch$ method sending data to the requesting application and the preceding read call that reads the data from the socket. The processing time goes up linearly with the object size. For example, NFD takes about 0.6 seconds to process a 1GB object. We found that it spends most of that time allocating, and creating an NFD object from the temporary buffer,  specifically on this line:

\begin{lstlisting}[breaklines]

isOk = Block::fromBuffer(m_inputBuffer + offset, m_inputBufferSize - offset, element);

\end{lstlisting}

\begin{figure}[!t]
\begin{center}
\includegraphics[width=\linewidth]{figures/receiver_side_time_vs_object_size.png}
\caption{Client Side Read Performance}
\label{fig:}
\end{center}
\end{figure}


\bibliographystyle{plain}
\bibliography{ref}

\end{document}
